<script lang="ts">
import Vue from 'vue';
import VueSlickCarousel from 'vue-slick-carousel';
import { IsMobileMixin } from '../../mixins';
import { PricingBanner } from '../pricing/index.vue';

export default Vue.extend({
  name: 'TierBlock',
  components: { VueSlickCarousel, PricingBanner },
  mixins: [IsMobileMixin],
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
  data() {
    return {
      activeCarouselIndex: 1,
    };
  },
  methods: {
    moveCarousel(index: number): void {
      const { tierCarousel } = this.$refs;
      this.activeCarouselIndex = index;
      if (tierCarousel.goTo) {
        tierCarousel.goTo(index);
      }
    },
    handleCarouselChange(index: number) {
      this.activeCarouselIndex = index;
    },
  },
});
</script>

<template>
  <section
    :id="data.id"
    class="tiers-block slp-mb-md-96 slp-mb-48"
    :class="data.class"
  >
    <SlpContainer>
      <SlpRow>
        <SlpColumn>
          <div class="tiers-block__header">
            <SlpTypography
              class="tiers-block__header-text"
              tag="h2"
              variant="heading2-bold"
            >
              {{ data.header }}
            </SlpTypography>
            <SlpButton
              v-if="data?.cta?.url"
              :href="data.cta.url"
              variant="tertiary"
              class="slp-mt-32 cta-button"
              :aria-label="data.cta.data_ga_name"
              :data-ga-name="data.cta.data_ga_name"
              :data-ga-location="data.cta.data_ga_location"
              >{{ data.cta.text || 'Learn more about pricing' }}
              <SlpIcon name="chevron-lg-right" variant="product" />
            </SlpButton>
          </div>
          <div v-if="isMobile" class="tiers-block__carousel_buttons">
            <button
              class="free"
              :class="{ active: activeCarouselIndex === 0 }"
              @click="moveCarousel(0)"
            >
              <SlpTypography variant="body1-bold"> Free</SlpTypography>
            </button>
            <button
              class="premium"
              :class="{ active: activeCarouselIndex === 1 }"
              @click="moveCarousel(1)"
            >
              <SlpTypography variant="body1-bold"> Premium</SlpTypography>
            </button>
            <button
              class="ultimate"
              :class="{ active: activeCarouselIndex === 2 }"
              @click="moveCarousel(2)"
            >
              <SlpTypography variant="body1-bold"> Ultimate</SlpTypography>
            </button>
          </div>
          <div>
            <component
              :is="isMobile ? 'VueSlickCarousel' : 'slp-row'"
              ref="tierCarousel"
              center-mode
              :center-padding="`${width / 50}%`"
              :infinite="false"
              :dots="true"
              class="tiers-block__tiers"
              :initial-slide="1"
              @afterChange="handleCarouselChange"
            >
              <SlpColumn
                v-for="tier in data.tiers"
                :key="tier.title"
                :cols="4"
                class="slp-flex"
              >
                <div
                  class="tiers-block__tier"
                  :class="[`tiers-block__tier--${tier.id}`]"
                >
                  <SlpTypography
                    tag="h3"
                    variant="heading3-bold"
                    class="slp-mb-16"
                  >
                    {{ tier.title }}
                  </SlpTypography>
                  <SlpTypography
                    v-if="tier.subtitle"
                    tag="p"
                    variant="body-2 italic-block"
                    class="slp-mb-16"
                  >
                    {{ tier.subtitle }}
                  </SlpTypography>
                  <ul>
                    <li
                      v-for="item in tier.items"
                      :key="item"
                      class="tiers-block__tier-item"
                    >
                      <SlpIcon
                        name="check"
                        class="slp-mr-16"
                        variant="product"
                        alt="Check icon"
                      />
                      <SlpTypography tag="span" variant="body2"
                        >{{ item }}
                      </SlpTypography>
                    </li>
                  </ul>
                  <SlpButton
                    v-if="tier.cta"
                    :href="tier.cta.href"
                    :data-ga-name="tier.cta.data_ga_name"
                    :data-ga-location="tier.cta.data_ga_location"
                    :aria-label="tier.cta.aria_label"
                  >
                    {{ tier.cta.text }}
                  </SlpButton>
                  <SlpButton
                    v-if="tier.link"
                    variant="tertiary"
                    class="tiers-block__tier-link"
                    :href="tier.link.href"
                    :data-ga-name="tier.link.data_ga_name"
                    :data-ga-location="tier.link.data_ga_location"
                    :aria-label="tier.link.aria_label"
                  >
                    {{ tier.link.text }}
                    <SlpIcon
                      class="slp-ml-8"
                      name="chevron-lg-right"
                      variant="product"
                      alt="Chevron Right Icon"
                    />
                  </SlpButton>
                </div>
              </SlpColumn>
            </component>
          </div>
        </SlpColumn>
      </SlpRow>
      <SlpRow v-if="data.banner">
        <PricingBanner :data="data.banner" :compact="true" />
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.tiers-block {
  max-width: 100%;
  &__header {
    display: flex;
    justify-content: space-between;
    align-items: flex-end;
    margin-bottom: $spacing-24;
    @media (max-width: $breakpoint-lg) {
      flex-wrap: wrap;
    }
  }

  &__header-text {
    @media (min-width: $breakpoint-lg) {
      max-width: 70%;
    }
  }

  &__tiers {
    display: flex;
    height: auto;

    &:deep {
      div {
        @media (max-width: $breakpoint-md) {
          height: 100%;
        }
      }

      .slick-track {
        display: flex !important;
      }

      .slick-slide {
        height: auto;
      }
    }
  }

  &__tier {
    padding: $spacing-24;
    margin: 0 $spacing-8;
    border-radius: 4px;
    height: 100%;

    @media (min-width: $breakpoint-md) {
      margin: 0 $spacing-16;
      padding: $spacing-32;
    }

    &--free {
      background-color: $color-surface-100;
    }

    &--premium {
      background-color: $color-surface-900;
    }

    &--ultimate {
      border-radius: 4px 4px 100px 4px;
      background: url('/nuxt-images/backgrounds/ultimate_tier_gradient.png');
      border: 1px solid $color-surface-900;
      border-top: none;
      background-size: cover;
      background-repeat: no-repeat;
      background-position: center center;
    }
  }

  &__tier-item {
    margin-bottom: $spacing-16;
    display: flex;
    align-items: baseline;
  }

  &__tier-link {
    padding-left: 0 !important;
    margin-top: 8px;
    &:hover {
      background-color: inherit !important;
    }
  }

  &__carousel_buttons {
    display: flex;
    width: 100%;
    justify-content: space-around;
    height: 42px;
    margin: $spacing-32 0;

    button {
      border: none;
      width: 100%;
      border-bottom: 1px solid transparent;
      opacity: 0.2;
      color: $color-primary-200;
      transition: all 0.3s ease-in-out;

      &.active {
        border-bottom: 1px solid #171321;
        opacity: 1;
      }
    }
  }
  .cta-button {
    @media (max-width: $breakpoint-lg) {
      width: 100%;
      padding: 0;
      margin-top: $spacing-24;
    }
  }
  .italic-block {
    font-style: italic;
  }
}
</style>
